<template>
  <div class="mb-2">
    <label :for="fieldPrefix + field.name" v-if="field.label">
      {{ field.label }}
      <RequiredIcon v-if="isRequired" />
      <InfoTooltip v-if="field.tooltip" :text="field.tooltip" />
    </label>
    <div class="input-group">
      <div class="input-group-prepend" v-if="field.iconClass">
        <span class="input-group-text">
          <i :class="field.iconClass"></i>
        </span>
      </div>
      <div class="vform-multiselect__input">
        <div class="form-check--select-all">
          <div class="form-check">
            <input
              class="form-check-input"
              type="checkbox"
              :id="`${fieldPrefix}${field.name}_selectall`"
              :checked="allSelected"
              :disabled="field.disabled || busy"
              @change="onCheckboxSelectAllChange"
            />
            <label class="form-check-label" :for="`${fieldPrefix}${field.name}_selectall`">Select All</label>
          </div>
        </div>
        <div class="vform-multiselect__options">
          <div v-for="(option, index) in checkedOptions" :key="index" class="form-check">
            <input
              class="form-check-input"
              type="checkbox"
              :value="option.value"
              :id="fieldPrefix + field.name + index"
              :checked="option.checked"
              :disabled="field.disabled || busy"
              @change="onCheckboxChange"
            />
            <label class="form-check-label" :for="fieldPrefix + field.name + index">{{ option.value }}</label>
          </div>
        </div>
      </div>
      <div class="input-group-append" v-if="field.buttonText || field.buttonIconClass">
        <button class="btn btn-primary" type="button" @click="onButton">
          <i aria-hidden="true" :class="field.buttonIconClass"></i>
          <span>{{ field.buttonText }}</span>
        </button>
      </div>
    </div>
    <div class="text-danger" v-if="error">{{ error }}</div>
  </div>
</template>

<script>
import { ref, computed } from 'vue'
import { useVFormControl } from '../../plugins/vform-plugin.js'
import InfoTooltip from '../info-tooltip.vue'
import RequiredIcon from '../required-icon.vue'

export default {
  name: 'VFormMultiSelect',
  emits: ['input', 'fieldInput'],
  props: {
    formName: { type: String, required: true },
    field: { type: Object, required: true },
    fieldPrefix: { type: String, required: true },
    modelState: { type: Object, default: null }, // Taken from the API response if validation fails at the server.
    busy: { type: Boolean, default: false },
  },
  components: {
    InfoTooltip,
    RequiredIcon,
  },
  setup(props, context) {
    const baseProperties = useVFormControl(props, context)

    const checkedOptions = ref([])

    const allSelected = computed(() => {
      return checkedOptions.value.filter((x) => !x.checked).length === 0
    })

    const onCheckboxChange = (e) => {
      const { value, checked } = e.target
      checkedOptions.value.find((x) => x.value === value).checked = checked

      const mutatedfield = JSON.parse(JSON.stringify(props.field))
      mutatedfield.value = checkedOptions.value
        .filter((x) => x.checked)
        .map((x) => x.value)
        .join()

      context.emit('input', e)
      context.emit('fieldInput', mutatedfield)
    }

    const onCheckboxSelectAllChange = (e) => {
      const { checked } = e.target
      for (let option of checkedOptions.value) {
        option.checked = checked
      }
    }

    const checkedValues = props.field.value && props.field.value.length > 0 ? props.field.value.split(',') : []

    checkedOptions.value = props.field.options.map((x) => {
      return {
        ...x,
        checked: checkedValues.find((y) => y === x.value),
      }
    })

    return {
      ...baseProperties,
      checkedOptions,
      allSelected,
      onCheckboxChange,
      onCheckboxSelectAllChange,
    }
  },
}
</script>

<style lang="scss">
@use '../../sass/vars';

.vform-multiselect__input {
  width: 100%;
  padding: 0.375rem 0.75rem;
  border: 1px solid vars.$separatorColor;
  border-radius: 0.25rem;
}

.form-check--select-all {
  padding-bottom: 0.375rem;
  border-bottom: 1px solid vars.$separatorColor;
  margin-bottom: 0.375rem;
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .vform-multiselect__options {
    column-width: 200px;
    column-count: auto;
  }
}

.dark {
  .vform-multiselect__input {
    border-color: vars.$darkSeparatorColor;
  }

  .form-check--select-all {
    border-color: vars.$darkSeparatorColor;
  }
}
</style>
